<?php
class nth
{
var $filedata;
var $cntrldir;
var $comment;
var $offset;
var $entries;
var $ztype;



function nth($_ztype='gzip')
{
$this->filedata = '';
$this->cntrldir = '';
$this->comment  = '';
$this->offset = 0;
$this->entries = 0;
switch(strtolower($_ztype))
{
case 'gzip' :
if (!function_exists('gzcompress'))
{
trigger_error('Your PHP installation does not support gzip compression',E_USER_ERROR);
}
$this->ztype = 'gzip';
break;
case 'bzip2':
if (!function_exists('bzcompress'))
{
trigger_error('Your PHP installation does not support bzip2 compression',E_USER_ERROR);
}
$this->ztype = 'bzip2';
break;
case 'stored':
$this->ztype = 'store';
break;
default :
$notice_msg = 'Unsupported compression type (' . $_ztype . ') using Stored instead';
$this->ztype = 'store';
trigger_error($notice_msg,E_USER_NOTICE);
}
}
function add_file($_data=null,$_name,$_timestamp=0)
{
if (is_null($_data))
{
$z_type = 'store';
$ext_fa = 0x10;
$_data = '';
}
elseif ($_data == '')
{
$z_type = 'store';
$ext_fa = 0x20;
}
else
{
$z_type = $this->ztype;
$ext_fa = 0x20;
}
$_name = trim(str_replace('\\\'', '/', $_name));
$_name = preg_replace('/^([A-z]:\/+|\.?\/+)/', '', $_name);
$mod_time = unix2dostime($_timestamp);
switch($z_type)
{
case  'gzip':
$min_ver = 0x14;
$zmethod = 0x08;
$c_data = gzcompress($_data);
$c_data = substr($c_data, 2, -4);
break;
case 'bzip2':
$min_ver = 0x2e;
$zmethod = 0x0c;
$c_data = bzcompress($_data);
break;
default :
$min_ver = 0x0a;
$zmethod = 0x00;
$c_data = $_data;
break;
}
$crc32 = crc32($_data);
$c_len = strlen($c_data);
$uc_len = strlen($_data);
$fn_len = strlen($_name);
$filedata = pack('VvvvVVVVvva' . $fn_len . 'a' . $c_len . 'VVVV', 0x04034b50,
$min_ver,
0x08,
$zmethod,
$mod_time,
0,
0,
0,
$fn_len,
0,
$_name,
$c_data,
0x08074b50,
$crc32,
$c_len,
$uc_len);
$this->filedata .= $filedata;
$this->cntrldir .= pack('VvvvvVVVVvvvvvVVa' . $fn_len,
0x02014b50,0x14,$min_ver,0x08,$zmethod,$mod_time,$crc32,$c_len,$uc_len,$fn_len,0,0,0,0,$ext_fa,$this->offset,
$_name);
$this->offset += strlen($filedata);
$this->entries++;
unset($c_data,$filedata,$ztype,$min_ver,$zmethod,$mod_time,$c_len,$uc_len,$fn_len);
}
function wallpaper($wallpaper)
{
$fp = fopen($wallpaper['tmp_name'],'rb');
$this->add_file(fread($fp,$wallpaper['size']),$wallpaper['name'],0);
fclose($fp);
}
function screensaver($screensaver)
{
$fp = fopen($screensaver['tmp_name'],'rb');
$this->add_file(fread($fp,$screensaver['size']),$screensaver['name'],0);
fclose($fp);
}
function ringtone($ringtone)
{
$fp = fopen($ringtone['tmp_name'],'rb');
$this->add_file(fread($fp,$ringtone['size']),$ringtone['name'],0);
fclose($fp);
}
function descriptor($theme_name,$color)
{
$data = '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE theme PUBLIC "-//NOKIA//DTD THEME 1.0//EN" "theme.dtd">
<theme name="' . $theme_name . '" version="1.0">
<wallpaper src="' . $this->wallpaper['name'] . '"/>
<screensaver src="' . $this->screensaver['name'] . '"/>
<ringtone src="' . $this->ringtone['name'] . '"/>
<colorscheme color="' . $color . '"/>
</theme>';
$this->add_file($data,'theme_descriptor.xml',0);
}
function build()
{
$com_len = strlen($this->comment);
return $this->filedata . $this->cntrldir . pack('VvvvvVVva' . $com_len,
0x06054b50,0,0,$this->entries,$this->entries,strlen($this->cntrldir),$this->offset,$com_len,$this->comment);
}
}
?>
